searchNodes=[{"doc":"Sets up a module for a protocol dispatch or a concrete implementation. Example defmodule PolymorphicCommand do use Dispatch , :protocol @callback cast ( term ( ) ) :: { :ok , term ( ) } | { :error , reason :: term ( ) } # this becoms the default implementation def cast ( _ ) , do : raise ArgumentError , &quot;unable to cast command description&quot; end defmodule ReadCommand do use Dispatch , for : PolymorphicCommand def cast ( %{ type : read , key : k } ) , do : { :read , k } end defmodule WriteCommand do use Dispatch , for : PolymorphicCommand def cast ( %{ type : :write , key : k , value : v } ) , do : { :write , k , v } end { :read , 1 } = PolymorphicCommand . cast ( %{ type : :read , key : 1 } ) { :write , 1 , :x } = PolymorphicCommand . cast ( %{ type : :write , key : 1 , value : :x } ) ` ` ` `","ref":"DispatchEx.html","title":"DispatchEx","type":"module"},{"doc":"","ref":"DispatchEx.html#def/2","title":"DispatchEx.def/2","type":"macro"},{"doc":"Consolidate protocols dispatch This does NOT use the elixir defprotocol functionality but instead builds a dispatch table based soly on pattern matching. The purpose beeing a more flexible dispatch built at compile time. Loads all the project files and their dependencies before scanning for the Dispatch behaviour. The modules implementing the protocol is parsed for their AST which the compiler merges with the original source file. The result is a single consolidated file with all the function clauses for the dispatch. The imlementing beam file may be discarded as it is not used.","ref":"Mix.Tasks.Compile.Dispatch.html","title":"Mix.Tasks.Compile.Dispatch","type":"task"},{"doc":"Compile time dispatch for patterns. Similar to Elixirs Protocol but uses pattern matching on the value.","ref":"readme.html","title":"DispatchEx","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding dispatchex to your list of dependencies in mix.exs : def project do [ # ... compilers : Mix . compilers ( ) ++ [ :dispatch ] ] def deps do [ # ... { :dispatchex , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/dispatchex .","ref":"readme.html#installation","title":"DispatchEx - Installation","type":"extras"},{"doc":"To add support for live reload compilation add to reloadable_compilers in config/dev.exs . config :phxapp_web , PhxApp.Endpoint , reloadable_compilers : [ :gettext , :phoenix , :elixir , :dispatch ] ,","ref":"readme.html#live-reload-phoenix","title":"DispatchEx - Live Reload &amp; Phoenix","type":"extras"},{"doc":"defmodule Castable do use DispatchEx , :protocol @callback cast ( term ( ) ) :: { :ok , term ( ) } | { :error , atom ( ) } # Add optional fallback clause, def cast ( _ ) , do : { :error , :fallback } end defmodule WrappedNumber do use DispatchEx , for : Castable def cast ( %{ &quot;type&quot; =&gt; &quot;number&quot; , &quot;value&quot; =&gt; v } ) , do : { :ok , { :integer , v } } end defmodule WrappedString do use DispatchEx , for : Castable def cast ( %{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;value&quot; =&gt; v } ) , do : { :ok , { :string , v } } end { :ok , { :string , &quot;abc&quot; } } = Castable . cast ( %{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;value&quot; =&gt; &quot;abc&quot; } ) { :ok , { :integer , 123 } } = Castable . cast ( %{ &quot;type&quot; =&gt; &quot;number&quot; , &quot;value&quot; =&gt; 123 } ) { :error , :fallback } = Castable . cast ( %{ } )","ref":"readme.html#simple-usage","title":"DispatchEx - Simple Usage","type":"extras"},{"doc":"Copyright 2022 FWT AS Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixes Correct ExDocs and links to git.","ref":"changelog.html#0-1-2-2022-10-05","title":"Changelog - [0.1.2] - 2022-10-05","type":"extras"},{"doc":"Fixes Adds callback ordering for functions to support multiple callbacks Only consolidate function clause header, function body should be kept in the original module Consolidated files with both function header and body works OK for trivial cases. The original module/function body may contain aliases, use/import etc, these will not be available in the consolidated module. Performing a remote call resolves any issues with the added bonus of providing better stacktraces.","ref":"changelog.html#0-1-1-2022-10-05","title":"Changelog - [0.1.1] - 2022-10-05","type":"extras"},{"doc":"Added Minimal compiler and dispatch functionality.","ref":"changelog.html#0-1-0-2022-10-02","title":"Changelog - [0.1.0] - 2022-10-02","type":"extras"}]